package at.jku.ssw.redblacktree.test;

import java.util.NoSuchElementException;

import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;

import at.jku.students.redblacktree.PreOrderTreeIterator;
import at.jku.students.redblacktree.RedBlackTree;

public class PreOrderTreeIteratorTest extends IteratorTestBase {

	@Rule
	public ExpectedException thrown = ExpectedException.none();

	@Test
	public void testException() {
		RedBlackTree tree = new RedBlackTree();
		PreOrderTreeIterator it = new PreOrderTreeIterator(tree);
		assertEquals(it);
		thrown.expect(NoSuchElementException.class);
		it.next();
	}

	@Test
	public void testEmpty() {
		RedBlackTree tree = new RedBlackTree();
		assertEquals(new PreOrderTreeIterator(tree));
	}

	@Test
	public void testSingle() {
		RedBlackTree tree = new RedBlackTree();
		tree.insert('X');
		assertEquals(new PreOrderTreeIterator(tree), 'X');
	}

}
